CodeMirror.defineMode("email", function() {

  var TOKEN_NAMES = {
    '>': 'comment',
    '>>': 'string',
    '#': 'comment'
  };

  return {
    token: function(stream) {
	  debugger
      var tw_pos = stream.string.search(/[\t ]+?$/);

      if (!stream.sol() || tw_pos === 0) {
        stream.skipToEnd();
        return ("error " + (
          TOKEN_NAMES[stream.string.charAt(0)] || '')).replace(/ $/, '');
      }

	  var token_name='';
	  if (stream.match(">>>")) {
		token_name='string';
		stream.skipToEnd();
	  }else if (stream.match(">>")) {
		token_name='tag';
		stream.skipToEnd();
	  }else if (stream.match(">")) {
		token_name='comment';
		stream.skipToEnd();
	  }

#      var token_name = TOKEN_NAMES[stream.peek()] || stream.skipToEnd();

      if (tw_pos === -1) {
        stream.skipToEnd();
      } else {
        stream.pos = tw_pos;
      }

      return token_name;
    }
  };
});

CodeMirror.defineMIME("text/x-email", "email");
